unit hiHDEClient;

interface

uses Windows,Messages,Kol,Share,Debug;

type
  THIHDEClient = class(TDebug)
   private
    FServiceName:string;
    strm1:PStream;
   public

    _data_Data:THI_Event;
    _event_onError:THI_Event;

    destructor Destroy; override;
    property _prop_ServiceName:string write FServiceName;
    procedure _work_doSend(var _Data:TData; Index:word);
    procedure _work_doServiceName(var _Data:TData; Index:word);
  end;

implementation

destructor THIHDEClient.Destroy;
begin
   free_and_nil(strm1);
   inherited;
end;

procedure THIHDEClient._work_doSend;
var   aCopyData: TCopyDataStruct;
      FWnd:THandle;
      strm:PStream;
      dt:TData;
      str: string;
begin
   dt := ReadData(_Data, _data_Data);
   FillChar(aCopyData, sizeof(aCopyData), #0);
   with aCopyData do begin
      dwData := _isType(dt);
      case dwData of
         data_int  : begin
            cbData := 4;
            lpData := @dt.idata;
         end; 
         data_str  : begin
            str := ToString(dt);
            if Assigned(Strm1) then free_and_nil(Strm1);
            Strm1 := NewMemoryStream;
            Strm1.Write(str[1],Length(str));
            Strm1.Position := 0;
            cbData := strm1.Size;
            lpData := strm1.Memory;
         end; 
         data_real : begin
            cbData := sizeof(Real);
            lpData := @dt.rdata; 
         end;
         data_stream: begin
            strm := ToStream(dt);
            cbData := strm.Size;
            lpData := strm.Memory; 
         end;
         data_bitmap: begin
         end;
         else exit;
      end;
   end;
   FWnd := FindWindow('HDE_Server', @FServiceName[1]);
   if FWnd <> 0 then 
      SendMessage(FWnd, WM_COPYDATA, Longint(Self), Longint(@aCopyData))   
   else
      _hi_CreateEvent(_Data, @_event_onError);
end;

procedure THIHDEClient._work_doServiceName;
begin
   FServiceName := ToString(_Data);
end;

end.