unit hiHDEServer;

interface

uses Windows,Messages,Kol,Share,Debug;

type
  THIHDEServer = class(TDebug)
   private
    FWnd:THandle;
    FServiceName:string;
   public

    _event_onReceive:THI_Event;

    property _prop_ServiceName:string write FServiceName;
    destructor Destroy; override;
    procedure _work_doStart(var _Data:TData; Index:word);
    procedure _work_doStop(var _Data:TData; Index:word);
    procedure _work_doServiceName(var _Data:TData; Index:word);
  end;

implementation

destructor THIHDEServer.Destroy;
begin
   Windows.DestroyWindow(FWnd);
   FWnd := 0;
   inherited;
end;

function NullWndProc(wnd:THandle; wMsg:cardinal; wParam,lParam:DWORD):DWORD; stdcall;
begin
  Result := DefWindowProc(wnd,wMsg,wParam,lParam);
end;

function MyWndProc(wnd:THandle; wMsg:cardinal; wParam,lParam:DWORD):DWORD; stdcall;
var   MySelf: THIHDEServer;
      aCopyData: PCopyDataStruct;
      Strm: PStream;
      str: string;
      i: integer;
      r: real;
begin
  FillChar(aCopyData, sizeof(aCopyData), #0);
  Result := 0;
  MySelf := THIHDEServer(GetWindowLong(wnd,GWL_USERDATA));
  case wMsg of
     WM_COPYDATA: begin
        aCopyData := PCopyDataStruct(lParam);
        case aCopyData.dwData of
           data_int   : begin
              i := integer(aCopyData.lpData^); 
              _hi_onEvent(MySelf._event_onReceive, i);
           end;   
           data_real  : begin 
              r := real(aCopyData.lpData^); 
              _hi_onEvent(MySelf._event_onReceive, r);
           end;              
           data_str   : begin
              Strm := NewMemoryStream;
              Strm.Write(aCopyData.lpData^, aCopyData.cbData);
              Strm.Position := 0;
              SetLength(Str,Strm.Size);
              if Length(str) > 0 then Strm.Read(Str[1],Length(str));
              _hi_onEvent(MySelf._event_onReceive, str);
              Strm.free;
           end;
           data_stream: begin
              Strm := NewMemoryStream;
              Strm.Write(aCopyData.lpData^, aCopyData.cbData);
              Strm.Position := 0;
              _hi_onEvent(MySelf._event_onReceive, Strm);
              Strm.free;
           end;   
        end;
        Result := 1;
     end;
  end;
end;

procedure THIHDEServer._work_doStart;
begin
   FWnd := CreateWindow('HDE_Server', @FServiceName[1], WS_POPUP, 0, 0, 0, 0, 0, 0, hInstance, nil);
   SetWindowLong(FWnd, GWL_WNDPROC, cardinal(@MyWndProc));   
   SetWindowLong(FWnd, GWL_USERDATA, cardinal(Self));
end;

procedure THIHDEServer._work_doStop;
begin
   Windows.DestroyWindow(FWnd);
   FWnd := 0;
end;

procedure THIHDEServer._work_doServiceName;
begin
   FServiceName := ToString(_Data);
   Windows.DestroyWindow(FWnd);
   FWnd := CreateWindow('HDE_Server', @FServiceName[1], WS_POPUP, 0, 0, 0, 0, 0, 0, hInstance, nil);
   SetWindowLong(FWnd, GWL_WNDPROC, cardinal(@MyWndProc));   
   SetWindowLong(FWnd, GWL_USERDATA, cardinal(Self));
end;

var MyWindowClass: TWndClass;

initialization

  MyWindowClass.style := 0;
  MyWindowClass.lpfnWndProc := @NullWndProc;
  MyWindowClass.cbClsExtra := 0;
  MyWindowClass.cbWndExtra := 0;
  MyWindowClass.hInstance := hInstance;
  MyWindowClass.hIcon := 0;
  MyWindowClass.hCursor := 0;
  MyWindowClass.hbrBackground := 0;
  MyWindowClass.lpszMenuName := nil;
  MyWindowClass.lpszClassName := 'HDE_Server';
  RegisterClass(MyWindowClass);
  
end.